
//stim::image<float> gaussian_derivative_filter_odd(stim::image<float> image, int r, unsigned int sigma_n, float theta);
//stim::image<float> func_mPb_theta(stim::image<float> img, float theta, int* r, float* alpha, int s);
//stim::image<float> func_mPb(stim::image<float> img, unsigned int theta_n, int* r, float* alpha, int s);

stim::image<float> dG1_conv2(stim::image<float> image, int sigma);
stim::image<float> dG2_conv2(stim::image<float> image, int sigma);
stim::image<float> dG1_theta_conv2(stim::image<float> image, int sigma, float theta);
stim::image<float> dG2_d2x_theta_conv2(stim::image<float> image, int sigma, float theta);
stim::image<float> laplacian_conv2(stim::image<float> image, int sigma);

stim::image<float> textons(stim::image<float> image, unsigned int theta_n);
stim::image<float> kmeans(stim::image<float> textons, unsigned int K);
stim::image<float> Pb(stim::image<float> image, int sigma);
stim::image<float> cPb(stim::image<float> img, int* sigma, float* alpha, int s);
stim::image<float> tPb(stim::image<float> img, int* r, float* alpha, unsigned int theta_n, unsigned int bin_n, int s, unsigned int K);